local BEAMNG = {}

local helper = require('scenario/scenariohelper')

local slowSpeed = false
local highSpeedA = false
local highSpeedB = false
local highSpeedC = false
local madeIt = false
local vehicle = nil

--core_environment.setTimeOfDay({time=1.0, play=false})

local function reset()
  slowSpeed = false
  highSpeedA = false
  highSpeedB = false
  highSpeedC = false
  madeIt = false
  vehicle = nil
end



local function onRaceStart()
  reset()

  helper.queueLuaCommandByName('sheriff', 'electrics.set_lightbar_signal(1)')
  helper.queueLuaCommandByName('sheriff', 'electrics.set_warn_signal(1)')
  helper.queueLuaCommandByName('sheriff', 'electrics.setLightsState(2)')
  helper.queueLuaCommandByName('tow', 'electrics.setLightsState(2)')
  --helper.queueLuaCommandByName('tow', 'powertrain.toggleDefaultDiffs()')
  vehicle = helper.getVehicleByName('load')
end


local function getVehicleSpeed()
  local playerData = map.objects[map.objectNames['tow']]

  return playerData.vel:length()
end


local function onBeamNGTrigger(data)
  local luaTrigger = data.triggerName

  if luaTrigger == 'trigger2' and not highSpeedB then
    helper.flashUiMessage("Your running late! Speed up to 59mph(94kmh)!", 7)
    highSpeedB = true

  elseif luaTrigger == 'trigger3' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 59mph(94kmh)! You wont make it to the harbor!"})

  elseif luaTrigger == 'trigger1' and not highSpeedA then
    helper.flashUiMessage("Maintain 34mph(56kmh)!", 4)
    highSpeedA = true

  elseif luaTrigger == 'trigger4' and not highSpeedC  then
    helper.flashUiMessage("Almost there! Speed up to 59mph(94kmh)!", 5)
    highSpeedC = true
    madeIt = false

  elseif luaTrigger == 'trigger5' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 59mph(94kmh)! You wont make it to the harbor!"})

  elseif luaTrigger == 'trigger6' and not highSpeedB then
    helper.flashUiMessage("Your running late! Speed up to 59mph(94kmh)!", 7)
    highSpeedB = true
    madeIt = false

  elseif luaTrigger == 'trigger7' and not madeIt then
    helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
    scenario_scenarios.finish({failed = "You did not reach 59mph(94kmh)! You wont make it to the harbor!"})
  end

end


local function onRaceWaypoint(data, goal)
  local wayPoint = data.waypointName

  if wayPoint == 'wp3' then
    helper.flashUiMessage("This is a company truck DO NOT go over 34mph(56kmh) while off road!", 7)
    slowSpeed = true

  elseif wayPoint == 'wp4' then
    slowSpeed = false
    helper.flashUiMessage("You are running late! Maintain 34mph(56kmh)!", 7)

  elseif wayPoint == 'wp5a' then
    highSpeedA = false
    helper.flashUiMessage("You're on time now! You can slow down!", 5)
  end

end


local function onRaceTick(raceTickTime)

  if slowSpeed then
    -- 15 35mph(56kmh)
    if getVehicleSpeed() > 15 then
      helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
      scenario_scenarios.finish({failed = "You're driving over 34mph(56kmh) while off road!. The boss is not happy!"})
    end

  elseif highSpeedA then
    -- 15 35mph(56kmh)
    if getVehicleSpeed() < 15 then

      helper.queueLuaCommand(vehicle, 'fire.explodeVehicle()')
      scenario_scenarios.finish({failed = "You did not maintain 34mph(56kmh)! You wont make it to the harbor!."})
    end
  end

  if highSpeedB then
    -- 25 59mph(94kmh)
    if getVehicleSpeed() >= 25 then
      highSpeedB = false
      madeIt = true
      helper.flashUiMessage("You reached 59mph(94kmh)! You can slow down!", 5)
    end
  elseif highSpeedC then
    -- 25 59mph(94kmh)
    if getVehicleSpeed() >= 25 then
      highSpeedC = false
      madeIt = true
      helper.flashUiMessage("You reached 59mph(94kmh)! Maintain 34mph(56kmh)!", 5)
    end
  end

end


BEAMNG.onBeamNGTrigger = onBeamNGTrigger
BEAMNG.onRaceTick = onRaceTick
BEAMNG.onRaceWaypoint = onRaceWaypoint
BEAMNG.onRaceStart = onRaceStart

return BEAMNG